<template>
    <div class="content-block">
        <div class='container'>
            <div class='margin-top-50'></div>
			<div class='row' v-if="creditRatingRequestsHistoryReady">
				<transition name="fade">
					<FillingForm v-if="activeContentComponentName === 'FillingForm'"
									v-bind="{
                                        formWithUserDataFields,
                                    }"
									@nextStep="setActiveContentComponentName"
					/>
					<Payment v-else-if="activeContentComponentName === 'Payment'"
							 v-bind="{
                                 formWithUserDataFields,
                             }"
							 @nextStep="setActiveContentComponentName"
					/>
					<CreditRating v-else-if="activeContentComponentName === 'CreditRating'"
								  v-bind="{formWithUserDataFields}"
								  @nextStep="setActiveContentComponentName"
					/>
					<!--ratingRequestList.length-->
					<CreditHistory v-else-if="activeContentComponentName === 'CreditHistory'"
								   @ratingRequest="setActiveContentComponentName('FillingForm')"
					/>
				</transition>
				<!--здесь loader-->
			</div>
        </div>
        <docs-list/>
    </div>
</template>

<script>
    import FillingForm from './Parts/FillingForm/'
    import CreditRating from './Parts/CreditRating/'
    import Payment from './Parts/Payment'
    import SpecifyMail from './Parts/SpecifyMail';
    import CreditHistory from './Parts/CreditHistory';
	import DocsList from '@/components/Modals/DocsList';

    export default {
        name: 'credit-rating',
        components: {
            CreditHistory,
            SpecifyMail,
            FillingForm,
            Payment,
            CreditRating,
			DocsList,
        },
		data() {
			return {
				creditRatingRequestsHistoryReady: false,
				formWithUserDataFields: {
					lastName: '',
					firstName: '',
					middleName: '',
					bDay: '',
					gender: 'male',
					passport: '',
					passportDivisionCode: '',
					passportDateOfIssue: '',
					passportIssuedBy: '',
					typeOfEmployment: '',
					workType: '',
					workSalary: 0,
					educationType: '',
					sourceOfInformation: '',
					compliance: true,
				},
				contentComponentNameRouts: [
					['FillingForm', 'filling-form'],
					['CreditHistory', 'credit-history'],
					['Payment', 'payment'],
					['CreditRating', 'result'],
				],
			}
		},

		computed: {
			storeCreditRatingState() {
				return this.$store.state.creditRating;
			},
			activeContentComponentName() {
				return this.storeCreditRatingState.activeContentComponentName;
			},
			creditRatingRequestsHistory() {
				return this.storeCreditRatingState.creditRatingRequestsHistory;
			},
		},

		watch: {
			activeContentComponentName(newValue) {
				/*поднятся ввверх к началу контента страницы*/
				this.$nextTick(() => {
					this.$helpers.scroll(this.$root.$el);
				});
				let routePageParam = 'filling-form';
				/*выбор активного параметра адресной строки в соответствии с установленным именем контента*/
				for(const contentComponentNameRoutEntry of this.contentComponentNameRouts) {
					if(contentComponentNameRoutEntry[0] === newValue) {
						routePageParam = contentComponentNameRoutEntry[1];
					}
				}
				/*изменить параметр адресной строки на актуальный*/
				this.$router.push({
					name: 'credit-rating',
					params: {
						page: routePageParam
					}
				});
			},
			$route: {
				handler(to, from) {
					const toPage = to.params.page;
					let contentComponentName = this.activeContentComponentName;
					/*выбор имени активного контента страницы в соответствии с параметрами в адресной строке*/
					for(const contentComponentNameRoutEntry of this.contentComponentNameRouts) {
						if(contentComponentNameRoutEntry[1] === toPage) {
							contentComponentName = contentComponentNameRoutEntry[0];
						}
					}
					/*установка активонго имени контента*/
					this.setActiveContentComponentName(contentComponentName);
				},
				immediate: true,
			},
		},

        methods: {
			setActiveContentComponentName(contentComponentName) {
				this.$store.commit('setActiveContentComponentName', contentComponentName);
			},
		},

        created() {
			const routePage = this.$route.params.page;
			this.AJAX_LOADING(true);
			this.$store.dispatch('getCreditRatingRequestsHistory')
				.finally(() => {
					/*если контент явно не определён через ссылку*/
					if(!routePage) {
						/*если исторя запросов не пуста*/
						if(this.creditRatingRequestsHistory.length) {
							/*установка компонента истории запросов как активный контент кредитной истории*/
							this.setActiveContentComponentName('CreditHistory');
						} else {
							this.setActiveContentComponentName('FillingForm');
						}
					}
					/*установка состояния готовности контента*/
					this.creditRatingRequestsHistoryReady = true;
					this.AJAX_LOADING(false);
				});
        },
    }
</script>
